%define gittag %(echo %version | cut -d+ -f2 | cut -d. -f2)
Name:          stb
Version:       0+20250314git.f056911
Release:       1mamba
Summary:       Single-file public domain (or MIT licensed) libraries for C/C++
Group:         System/Libraries
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://github.com/nothings/stb
Source:        https://github.com/nothings/stb.git/master@%{gittag}/stb-%{version}.tar.bz2
Source1:       stb.pc
Patch0:        https://github.com/nothings/stb/pull/1194.patch
Patch1:        https://github.com/nothings/stb/pull/1195.patch
Patch2:        https://github.com/nothings/stb/pull/1196.patch
Patch3:        https://github.com/nothings/stb/pull/1198.patch
Patch4:        https://github.com/nothings/stb/pull/1236.patch
Patch5:        https://github.com/nothings/stb/pull/1454.patch
Patch6:        https://github.com/nothings/stb/pull/1530.patch
Patch7:        https://github.com/nothings/stb/pull/1532.patch
Patch8:        https://github.com/nothings/stb/pull/1534.patch
Patch9:        https://github.com/nothings/stb/pull/1539.patch
Patch10:       https://github.com/nothings/stb/pull/1541.patch
Patch11:       https://github.com/nothings/stb/pull/1543.patch
Patch12:       https://github.com/nothings/stb/pull/1553.patch
Patch13:       https://github.com/nothings/stb/pull/1559.patch
Patch14:       https://github.com/nothings/stb/pull/1736.patch
Patch20:       stb-0+20250314git.f056911-Fix-double-free-in-stbi__load_gif_main_outofmem.patch
Patch21:        stb-0+20250314git.f056911-Fix-possible-double-free-or-memory-leak-in-stbi__loa.patch
Patch22:       stb-0+20250314git.f056911-Fix-Null-pointer-dereference-because-of-an-uninitial.patch
License:       MIT, Public Domain
BuildArch:     noarch
## AUTOBUILDREQ-BEGIN
## AUTOBUILDREQ-END

%description
Single-file public domain (or MIT licensed) libraries for C/C++.

%package -n lib%{name}-devel
Summary:       Single-file public domain (or MIT licensed) libraries for C/C++
Group:         Development/Libraries

%description -n lib%{name}-devel
Single-file public domain (or MIT licensed) libraries for C/C++.
This package contains header files for developing applications that use %{name}.

%prep
%setup -q
%patch 0 -p1
%patch 1 -p1
%patch 2 -p1
%patch 3 -p1
%patch 4 -p1
%patch 5 -p1
%patch 6 -p1
%patch 7 -p1
%patch 8 -p1
%patch 9 -p1
%patch 10 -p1
%patch 11 -p1
%patch 12 -p1
%patch 13 -p1
%patch 14 -p1
%patch 20 -p1 -b .Fix-double-free-in-stbi__load_gif_main_outofmem
%patch 21 -p1 -b .Fix-possible-double-free-or-memory-leak-in-stbi__loa
%patch 22 -p1 -b .Fix-Null-pointer-dereference-because-of-an-uninitial

# From Fedora:
# Append to OS build flags rather than overriding them
#
# Instead of hard-coding C++ standard and calling the C compiler, defer to the
# default and call the C++ compiler.
#
# When upstream says CPPFLAGS, they
# mean C++ flags, i.e. CXXFLAGS, not “C PreProcessor Flags” as is common in
# autoconf-influenced projects.
sed -r -i \
    -e 's/([[:alpha:]]+FLAGS[[:blank:]]*)=/\1+=/' \
    -e 's/(\$\(CC\))(.*)-std=[^[:blank:]]+/\$\(CXX\)\2/' \
    -e 's/CPPFLAGS/CXXFLAGS/' tests/Makefile

# Add a dummy main(); how does this one work upstream?! Note that omitting
# parameter names is a C++-ism.
echo 'int main(int, char *[]) { return 0; }' >> tests/test_cpp_compilation.cpp

# Remove any pre-compiled Windows executables
find . -type f -name '*.exe' -print -delete

# Remove some unused parts of the source tree that could contribute different
# (but acceptable) license terms if they were used—just to prove that we do not
# use them.
rm -rvf tests/caveview
find deprecated -type f ! -name 'stb_image_resize.h' -print -delete

%build
%make_build -C tests

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
	
install -t '%{buildroot}%{_includedir}/stb' -p -m 0644 -D \
    stb_*.h stb_*.c deprecated/stb_image_resize.h
	
%if %{without stb_include}
rm -vf '%{buildroot}%{_includedir}/stb/stb_include.h'
%endif
	
pushd '%{buildroot}%{_includedir}'
ln -sv stb/stb_*.? .
popd

install -D -m0644 %{SOURCE1} %{buildroot}%{_datadir}/pkgconfig/stb.pc

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%files -n lib%{name}-devel
%defattr(-,root,root)
%dir %{_includedir}/stb
%{_includedir}/stb/stb*.h
%{_includedir}/stb/stb_vorbis.c
%{_includedir}/stb_*.h
%{_includedir}/stb_vorbis.c
%{_datadir}/pkgconfig/stb.pc
%doc LICENSE README.md

%changelog
* Sun Mar 23 2025 Silvan Calarco <silvan.calarco@mambasoft.it> 0+20250314git.f056911-1mamba
- package created using the webbuild interface
